/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Vista;

import DAO.ClaseBBDD;
import Negocio.BookClass;
import Negocio.BookProcess;
import Negocio.PrestamoClass;
import Negocio.PrestamosProcess;
import Negocio.UserClass;
import Negocio.UserProcess;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Abraham Fernandez Sanchez
 */

public class PrestamoActualVista extends javax.swing.JInternalFrame {
    
    Escritorio escritorio ;
    ClaseBBDD bbdd;
    PrestamoClass prestamo;
    DefaultTableModel modelo;
    UserProcess userProcess;
    UserClass user;
    PrestamosProcess prestamosProcess;
    BookProcess bookProcess;
    BookClass bookClass;
      
    
    /**
     * Cosnstructor de la clase PrestamoActualVista
     * Creates new form PrestamoActualVista
     * @param escritorio Objeto de la clase Escritorio
     */
    public PrestamoActualVista( Escritorio escritorio ) {
        this.escritorio = escritorio;
        initComponents();
        modelo = (DefaultTableModel) jTableListadoPrestamos.getModel();
        
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel8 = new javax.swing.JLabel();
        jTextFieldBuscarNumCarnet = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableListadoPrestamos = new javax.swing.JTable();
        jButtonBuscar = new javax.swing.JButton();
        jPanelDatosUsuario = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jTextFieldNCarnet = new javax.swing.JTextField();
        jTextFieldNombre = new javax.swing.JTextField();
        jTextFieldApellidos = new javax.swing.JTextField();
        jTextFieldTelefono = new javax.swing.JTextField();
        jTextFieldEmail = new javax.swing.JTextField();
        jTextFieldDireccion = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();

        jLabel8.setText("jLabel8");

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setTitle("Prestamos Actuales");

        jTableListadoPrestamos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null}
            },
            new String [] {
                "ID", "ISBN", "TITULO", "F. SALIDA"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.Object.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jTableListadoPrestamos.setToolTipText("");
        jScrollPane1.setViewportView(jTableListadoPrestamos);

        jButtonBuscar.setText("Buscar");
        jButtonBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonBuscarActionPerformed(evt);
            }
        });

        jLabel1.setText("N. Carnet :");

        jLabel2.setText("Nombre :");

        jLabel3.setText("Apellidos :");

        jLabel4.setText("Direccion :");

        jLabel6.setText("Telefono :");

        jLabel7.setText("Email :");

        jTextFieldNCarnet.setEnabled(false);

        jTextFieldNombre.setEnabled(false);

        jTextFieldApellidos.setEnabled(false);

        jTextFieldTelefono.setEnabled(false);

        jTextFieldEmail.setEnabled(false);

        jTextFieldDireccion.setEnabled(false);

        javax.swing.GroupLayout jPanelDatosUsuarioLayout = new javax.swing.GroupLayout(jPanelDatosUsuario);
        jPanelDatosUsuario.setLayout(jPanelDatosUsuarioLayout);
        jPanelDatosUsuarioLayout.setHorizontalGroup(
            jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelDatosUsuarioLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel3)
                    .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jTextFieldNombre, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextFieldApellidos, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 140, Short.MAX_VALUE)
                    .addComponent(jTextFieldNCarnet))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jTextFieldEmail)
                    .addComponent(jTextFieldDireccion)
                    .addComponent(jTextFieldTelefono))
                .addContainerGap())
        );
        jPanelDatosUsuarioLayout.setVerticalGroup(
            jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelDatosUsuarioLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelDatosUsuarioLayout.createSequentialGroup()
                        .addComponent(jTextFieldTelefono, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(jTextFieldEmail, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jTextFieldDireccion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanelDatosUsuarioLayout.createSequentialGroup()
                        .addGroup(jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(jLabel6)
                            .addComponent(jTextFieldNCarnet, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(10, 10, 10)
                        .addGroup(jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel2)
                            .addComponent(jLabel7)
                            .addComponent(jTextFieldNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addGroup(jPanelDatosUsuarioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jTextFieldApellidos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel4)))))
                .addContainerGap(17, Short.MAX_VALUE))
        );

        jLabel5.setText("N. Carnet :");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(5, 5, 5)
                        .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, 77, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldBuscarNumCarnet, javax.swing.GroupLayout.PREFERRED_SIZE, 296, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, 127, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane1)
                    .addComponent(jPanelDatosUsuario, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(4, 4, 4)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldBuscarNumCarnet, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonBuscar)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelDatosUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonBuscarActionPerformed
        
        try {
            mostrarAllDatosVista(jTextFieldBuscarNumCarnet.getText());
        } catch (SQLException | NumberFormatException ex) {            
            Logger.getLogger(PrestamoActualVista.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }//GEN-LAST:event_jButtonBuscarActionPerformed
    
    /**
     * Mostrar datos de la consulta realizada<br>
     * 
     * Metodo que muestra agrupa los distintos metodos que son usados para mostrar la informacion de la consulta realizada.
     * 
     * @param nCarnet parametro que contendra el valor del numero de carnet de usuario
     * @throws SQLException Excepcion de tipo SQL
     */
    public void mostrarAllDatosVista(String nCarnet) throws SQLException{    
        userProcess = new UserProcess();
        if(userProcess.isNumCarnetExist(nCarnet)){            
            clearjText();
            mostrarUsuario();
            mostrarListadoPrestamos();
        }else{    
             if(isModeloRowExists()){deleteRowsModelo();}  
                JOptionPane.showMessageDialog(escritorio, "El numero de carnet introducido no existe");
                clearjText();
        }
    
    }    
    
    /**
     * Muestra usuario <br>
     * 
     * Metodo que muestra en los JText los datos del usuario requerio por la consulta realizada
     * 
     * @throws SQLException Excepcion de tipo SQL
     */
    public void mostrarUsuario() throws SQLException{      
        String numCarnet = jTextFieldBuscarNumCarnet.getText();        
        userProcess = new UserProcess();
        user = userProcess.getUser(numCarnet);  
        jTextFieldNCarnet.setText(user.getNumCarnet());
        jTextFieldNombre.setText(user.getNombre());
        jTextFieldApellidos.setText(user.getApellidos());
        jTextFieldTelefono.setText(user.getTlf());
        jTextFieldEmail.setText(user.getEmail());      
        jTextFieldDireccion.setText(user.getDireccion());
    }
    
    /**
     * Mostrar listados de prestamos realizados<br>
     * 
     * Metodo que añadira al modelo de la table las filas con los datos oportunos de cada consulta.
     * 
     * @throws java.sql.SQLException Excepcion de tipo SQL
     */
    public void mostrarListadoPrestamos() throws SQLException{          
       
        if(isModeloRowExists()){deleteRowsModelo();}   
        prestamosProcess = new PrestamosProcess(); 
        
//        prestamo = new PrestamoClass();
         ArrayList listaPres = prestamosProcess.showPrestamosActualesUsuario(jTextFieldNCarnet.getText()); 
         for (int i = 0; i < listaPres.size(); i++) {             
            prestamo = (PrestamoClass) listaPres.get(i);   
            bookProcess = new BookProcess();
            String nIsbn = prestamo.getIsbn();
            
            bookClass = bookProcess.recoverObjBook(nIsbn);
            String titulo = bookClass.getTitulo();
            
             System.out.println(""+titulo);
                   
//            bookClass = bookProcess.getBook(prestamo.getIsbn());
//            String tituloBook = bookClass.getTitulo();
             modelo.addRow(new Object[]{prestamo.getId(), prestamo.getIsbn(), titulo, prestamo.getFechaSalida(), prestamo.getFechaDevolucion()});   
//             modelo.addRow(new Object[]{prestamo.getId(), prestamo.getIsbn(), prestamo.getnCarnet(), prestamo.getFechaSalida(), prestamo.getFechaDevolucion()});
             
         } 
    }
    
    /**
     * Metodo que devolvera si existen filas o no en el modelo de JTable <br>
     * 
     * @return retorna booleano
     */
    public boolean isModeloRowExists(){ 
        return modelo.getRowCount()>0; 
    }
    
    /**
     * Metodo con el cual se borraran las filas existentes en la JTable <br>
     * 
     */
    public void deleteRowsModelo(){   
        try {
            int numRows = modelo.getRowCount();
            for (int i = 0; i < numRows; i++) {
                modelo.removeRow(i);
            }   
        } catch (Exception e) {
        }    
      
    }
    
    /**
     * 
     * Metodo para borrar el texto contenido en los JText<br>
     * 
     */
    public void clearjText(){
        jTextFieldNCarnet.setText("");
        jTextFieldNombre.setText("");
        jTextFieldApellidos.setText("");
        jTextFieldTelefono.setText("");
        jTextFieldEmail.setText("");     
        jTextFieldDireccion.setText("");
    }

    
    
    
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonBuscar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanelDatosUsuario;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableListadoPrestamos;
    private javax.swing.JTextField jTextFieldApellidos;
    private javax.swing.JTextField jTextFieldBuscarNumCarnet;
    private javax.swing.JTextField jTextFieldDireccion;
    private javax.swing.JTextField jTextFieldEmail;
    private javax.swing.JTextField jTextFieldNCarnet;
    private javax.swing.JTextField jTextFieldNombre;
    private javax.swing.JTextField jTextFieldTelefono;
    // End of variables declaration//GEN-END:variables
}
